*** linux-2.0.28/net/ipv4/af_inet.c	Thu Oct 17 21:18:54 1996
--- KERNEL/net/ipv4/af_inet.c	Mon Nov 24 22:51:53 1997
***************
*** 113,118 ****
--- 113,122 ----
  extern int afinet_get_info(char *, char **, off_t, int, int);
  extern int tcp_get_info(char *, char **, off_t, int, int);
  extern int udp_get_info(char *, char **, off_t, int, int);
+ #ifdef CONFIG_WEBSHIELD_DEBUG
+ extern int WSsocklog_get_info(char *, char **, off_t, int, int);
+ extern int WSbridgelog_get_info(char *, char **, off_t, int, int);
+ #endif /* CONFIG_WEBSHIELD_DEBUG */
  
  #ifdef CONFIG_DLCI
  extern int dlci_ioctl(unsigned int, void*);
***************
*** 159,164 ****
--- 163,169 ----
  	int best = 0;
  	int size = 32767; /* a big num. */
  	struct sock *sk;
+ 	unsigned long flags;
  
  	if (base == 0) 
  		base = PROT_SOCK+1+(start & 1023);
***************
*** 171,176 ****
--- 176,184 ----
  	 *	Now look through the entire array and try to find an empty ptr. 
  	 */
  	 
+ 	/* We can't have this changing out from under us. */
+ 	save_flags(flags);
+ 	cli();
  	for(i=0; i < SOCK_ARRAY_SIZE; i++) 
  	{
  		j = 0;
***************
*** 183,188 ****
--- 191,197 ----
  		if (j == 0) 
  		{
  			start =(i+1+start )&1023;
+ 			restore_flags(flags);
  			return(i+base+1);
  		}
  		if (j < size) 
***************
*** 198,203 ****
--- 207,213 ----
  	{
  		best += SOCK_ARRAY_SIZE;
  	}
+ 	restore_flags(flags);
  	return(best+base+1);
  }
  
***************
*** 266,272 ****
   *	Remove a socket from the socket tables.
   */
  
! static void remove_sock(struct sock *sk1)
  {
  	struct sock **p;
  	unsigned long flags;
--- 276,282 ----
   *	Remove a socket from the socket tables.
   */
  
! void remove_sock(struct sock *sk1)
  {
  	struct sock **p;
  	unsigned long flags;
***************
*** 306,312 ****
--- 316,326 ----
  void destroy_sock(struct sock *sk)
  {
  	struct sk_buff *skb;
+ #ifdef CONFIG_WEBSHIELD_DEBUG
+ 	extern struct timer_list *find_timer(struct timer_list *t);
+ #endif CONFIG_WEBSHIELD_DEBUG
  
+ 	log_sockevent(sk, 13, sk->rmem_alloc, sk->wmem_alloc);
  	lock_sock(sk);			/* just to be safe. */
  
    	remove_sock(sk);
***************
*** 319,325 ****
    	delete_timer(sk);
  	del_timer(&sk->delack_timer);
  	del_timer(&sk->retransmit_timer);
! 	
  	/*
  	 *	Drain any partial frames
  	 */
--- 333,351 ----
    	delete_timer(sk);
  	del_timer(&sk->delack_timer);
  	del_timer(&sk->retransmit_timer);
! 
! #ifdef CONFIG_WEBSHIELD_DEBUG
! #if 0
! /* This timer is never used, so it is not even initialized. */
! 	if (find_timer(sk->keepalive_timer)) {
! 		printk("destroy_sock: found a keepalive timer at %p, %p, %p\n",
! 			__builtin_return_address(0),
! 			__builtin_return_address(1),
! 			__builtin_return_address(2));
! 	}
! #endif
! #endif CONFIG_WEBSHIELD_DEBUG
! 
  	/*
  	 *	Drain any partial frames
  	 */
***************
*** 329,334 ****
--- 355,368 ----
  		IS_SKB(skb);
  		kfree_skb(skb, FREE_WRITE);
  	}
+ #ifdef CONFIG_WEBSHIELD_DEBUG
+ 	if (find_timer(&sk->partial_timer)) {
+ 		printk("destroy_sock: found a partial timer at %p, %p, %p\n",
+ 			__builtin_return_address(0),
+ 			__builtin_return_address(1),
+ 			__builtin_return_address(2));
+ 	}
+ #endif CONFIG_WEBSHIELD_DEBUG
  
  	/*
  	 *	Cleanup up the write buffer. 
***************
*** 841,847 ****
  	}
  	
  	chk_addr_ret = ip_chk_addr(addr->sin_addr.s_addr);
! #ifdef CONFIG_IP_TRANSPARENT_PROXY
  	/*
  	 * Superuser may bind to any address to allow transparent proxying.
  	 */
--- 875,886 ----
  	}
  	
  	chk_addr_ret = ip_chk_addr(addr->sin_addr.s_addr);
! /* WAS_PROXY is used in this port in place of CONFIG_OP_TRANSPARENT_PROXY
!  * (TP).  I did not need all the TP stuff, but it looks good here.
!  * Eventually this will be undone.
!  */
! #define WAS_PROXY
! #ifdef WAS_PROXY
  	/*
  	 * Superuser may bind to any address to allow transparent proxying.
  	 */
***************
*** 851,857 ****
  #endif
  		return(-EADDRNOTAVAIL);	/* Source address MUST be ours! */
  
! #ifndef CONFIG_IP_TRANSPARENT_PROXY
  	/*
  	 * Am I just thick or is this test really always true after the one
  	 * above?  Just taking the test out appears to be the easiest way to
--- 890,896 ----
  #endif
  		return(-EADDRNOTAVAIL);	/* Source address MUST be ours! */
  
! #ifndef WAS_PROXY
  	/*
  	 * Am I just thick or is this test really always true after the one
  	 * above?  Just taking the test out appears to be the easiest way to
***************
*** 873,879 ****
  			sk->saddr = 0;  /* Use device */
  		else
  			sk->saddr = addr->sin_addr.s_addr;
! #ifndef CONFIG_IP_TRANSPARENT_PROXY
  	}
  #endif
  	if(sock->type != SOCK_RAW)
--- 912,918 ----
  			sk->saddr = 0;  /* Use device */
  		else
  			sk->saddr = addr->sin_addr.s_addr;
! #ifndef WAS_PROXY
  	}
  #endif
  	if(sock->type != SOCK_RAW)
***************
*** 1317,1327 ****
  
  		case SIOCGIFBR:
  		case SIOCSIFBR:
  #ifdef CONFIG_BRIDGE		
  			return(br_ioctl(cmd,(void *) arg));
  #else
  			return -ENOPKG;
! #endif						
  			
  		case SIOCADDDLCI:
  		case SIOCDELDLCI:
--- 1356,1368 ----
  
  		case SIOCGIFBR:
  		case SIOCSIFBR:
+ 		case SIOCBRDEBUG:
+ 		case SIOCBRNODEBUG:
  #ifdef CONFIG_BRIDGE		
  			return(br_ioctl(cmd,(void *) arg));
  #else
  			return -ENOPKG;
! #endif
  			
  		case SIOCADDDLCI:
  		case SIOCDELDLCI:
***************
*** 1406,1411 ****
--- 1447,1453 ----
  	unsigned short hpnum;
  	int firstpass = 1;
  #endif 
+ 	unsigned long flags;
  
  	hnum = ntohs(num);
  #ifdef CONFIG_IP_TRANSPARENT_PROXY
***************
*** 1421,1426 ****
--- 1463,1471 ----
  	 * socket number when we choose an arbitrary one.
  	 */
  
+ 	/* We can't have this changing out from under us. */
+ 	save_flags(flags);
+ 	cli();
  #ifdef CONFIG_IP_TRANSPARENT_PROXY
  	for(s = get_sock_loop_init(hnum, hpnum, s, &firstpass, prot);
  		s != NULL;
***************
*** 1479,1485 ****
--- 1524,1533 ----
  #else
  		if (score == 3)
  #endif
+ 		{
+ 			restore_flags(flags);
  			return s;
+ 		}
  		/* no, check if this is the best so far.. */
  		if (score <= badness)
  			continue;
***************
*** 1494,1499 ****
--- 1542,1548 ----
  		result = s;
  		badness = score;
    	}
+ 	restore_flags(flags);
    	return result;
  }
  
***************
*** 1734,1738 ****
--- 1783,1801 ----
  		0, &proc_net_inode_operations,
  		rt_cache_get_info
  	});
+ #ifdef CONFIG_WEBSHIELD_DEBUG
+ 	proc_net_register(&(struct proc_dir_entry) {
+ 		PROC_NET_WSSOCKLOG, 9, "WSsocklog",
+ 		S_IFREG | S_IRUGO, 1, 0, 0,
+ 		0, &proc_net_inode_operations,
+ 		WSsocklog_get_info
+ 	});
+ 	proc_net_register(&(struct proc_dir_entry) {
+ 		PROC_NET_WSBRIDGELOG, 11, "WSbridgelog",
+ 		S_IFREG | S_IRUGO, 1, 0, 0,
+ 		0, &proc_net_inode_operations,
+ 		WSbridgelog_get_info
+ 	});
+ #endif /* CONFIG_WEBSHIELD_DEBUG */
  #endif		/* CONFIG_PROC_FS */
  }
*** linux-2.0.28/net/ipv4/arp.c	Tue Oct 29 17:42:42 1996
--- KERNEL/net/ipv4/arp.c	Thu Jul 31 12:02:53 1997
***************
*** 1163,1169 ****
  	hash = HASH(sip);
  
  	for (entry=arp_tables[hash]; entry; entry = entry->next)
! 		if (entry->ip == sip && entry->dev == dev)
  			break;
  
  	if (entry)
--- 1163,1169 ----
  	hash = HASH(sip);
  
  	for (entry=arp_tables[hash]; entry; entry = entry->next)
! 		if (entry->ip == sip)
  			break;
  
  	if (entry)
***************
*** 1249,1255 ****
  	struct arp_table *entry;
  
  	for (entry = arp_tables[HASH(paddr)]; entry != NULL; entry = entry->next)
! 		if (entry->ip == paddr && (!dev || entry->dev == dev))
  			return entry;
  	return NULL;
  }
--- 1249,1257 ----
  	struct arp_table *entry;
  
  	for (entry = arp_tables[HASH(paddr)]; entry != NULL; entry = entry->next)
! 		/* Bridging code does not like device comparisons. */
! 		/* Add a check for nonzero pa_addr (for external interface). */
! 		if (entry->ip == paddr && (entry->dev && entry->dev->pa_addr))
  			return entry;
  	return NULL;
  }
***************
*** 1391,1396 ****
--- 1393,1421 ----
  		return 0;
  	}
  
+ 	/* Fake ARP for scanned connections. */
+ 	/* Connection setup may have a scanpair with no scandev */
+ 	if (skb && skb->sk && (skb->sk->scandev || skb->sk->scanpair))
+ 	{
+ 		/* Return the dest MAC addr most recently */
+ 		/* used by the peer. */
+ 		int i;
+ 		int gotit=0;
+ 
+ 		for (i=0; i<dev->addr_len; i++)
+ 		{
+ 			if ((haddr[i] = skb->sk->hw_addr[i]) != 0)
+ 				gotit++;
+ 		}
+ 		if (gotit)
+ 		{
+ 			/* valid address: at least 1 nonzero byte */
+ 			skb->arp = 1;
+ 			return 0;
+ 		}
+ 		/* else try a regular ARP lookup */
+ 	}
+ 
  	hash = HASH(paddr);
  	arp_fast_lock();
  
***************
*** 1585,1591 ****
  			hash = HASH(sip);
  
  			for (entry1 = arp_tables[hash]; entry1; entry1 = entry1->next)
! 				if (entry1->ip == sip && entry1->dev == dev)
  					break;
  
  			if (!entry1)
--- 1610,1616 ----
  			hash = HASH(sip);
  
  			for (entry1 = arp_tables[hash]; entry1; entry1 = entry1->next)
! 				if (entry1->ip == sip)
  					break;
  
  			if (!entry1)
***************
*** 1676,1681 ****
--- 1701,1707 ----
  	struct sk_buff *skb;
  	struct arphdr *arp;
  	unsigned char *arp_ptr;
+ 	extern char *a2b_src_hw(struct device *dev, unsigned char *);
  
  	/*
  	 *	No arp on this interface.
***************
*** 1684,1689 ****
--- 1710,1718 ----
  	if (dev->flags&IFF_NOARP)
  		return;
  
+ 	/* Let bridging code set source hw addr to internal hw addr. */
+ 	src_hw = a2b_src_hw(dev, src_hw);
+ 
  	/*
  	 *	Allocate a buffer
  	 */
***************
*** 2063,2069 ****
  	{
  		/* User supplied arp entries are definitive - RHP 960603 */
  
! 		if (entry->ip == ip && entry->mask == mask && entry->dev == dev) {
  			*entryp=entry->next;
  			arp_free_entry(entry);
  			continue;
--- 2092,2098 ----
  	{
  		/* User supplied arp entries are definitive - RHP 960603 */
  
! 		if (entry->ip == ip && entry->mask == mask) {
  			*entryp=entry->next;
  			arp_free_entry(entry);
  			continue;
*** linux-2.0.28/net/ipv4/devinet.c	Tue May  7 05:22:30 1996
--- KERNEL/net/ipv4/devinet.c	Thu Jul 31 12:02:53 1997
***************
*** 117,129 ****
  	{
  		if ((!(dev->flags & IFF_UP)) || dev->family!=AF_INET)
  			continue;
- 		/*
- 		 *	If the protocol address of the device is 0 this is special
- 		 *	and means we are address hunting (eg bootp).
- 		 */
  		 
- 		if (dev->pa_addr == 0)
- 			return IS_MYADDR;
  		/*
  		 *	Is it the exact IP address? 
  		 */
--- 117,123 ----
*** linux-2.0.28/net/ipv4/ip_input.c	Thu Jun  6 11:22:24 1996
--- KERNEL/net/ipv4/ip_input.c	Thu Jul 31 12:02:53 1997
***************
*** 426,431 ****
--- 426,434 ----
  	 *	function entry.
  	 */
  	daddr = iph->daddr;
+ #if 0
+ /* This stuff is turned off for the initial port. */
+ /* It may be turned back on in another pass. */
  #ifdef CONFIG_IP_TRANSPARENT_PROXY
  	/*
  	 *	ip_chksock adds still more overhead for forwarded traffic...
***************
*** 434,439 ****
--- 437,445 ----
  #else
  	if ( iph->daddr == skb->dev->pa_addr || (brd = ip_chk_addr(iph->daddr)) != 0)
  #endif
+ #endif /* 0 */
+ 	if (skb->ipcatch || iph->daddr == skb->dev->pa_addr ||
+ 		(brd = ip_chk_addr(iph->daddr)) != 0)
  	{
  		if (opt && opt->srr) 
  	        {
*** linux-2.0.28/net/ipv4/ip_output.c	Tue Oct 29 17:42:42 1996
--- KERNEL/net/ipv4/ip_output.c	Thu Jul 31 12:02:52 1997
***************
*** 163,169 ****
  	skb_reserve(skb,MAX_HEADER);
  	if (dev->hard_header)
  	{
! 		if (rt && dev == rt->rt_dev && rt->rt_hh)
  		{
  			memcpy(skb_push(skb,dev->hard_header_len),rt->rt_hh->hh_data,dev->hard_header_len);
  			if (rt->rt_hh->hh_uptodate)
--- 163,170 ----
  	skb_reserve(skb,MAX_HEADER);
  	if (dev->hard_header)
  	{
! 		if (rt && dev == rt->rt_dev && rt->rt_hh &&
! 		    (!skb->sk || !skb->sk->scandev))
  		{
  			memcpy(skb_push(skb,dev->hard_header_len),rt->rt_hh->hh_data,dev->hard_header_len);
  			if (rt->rt_hh->hh_uptodate)
*** linux-2.0.28/net/ipv4/proc.c	Mon Jun  3 04:23:42 1996
--- KERNEL/net/ipv4/proc.c	Mon Nov 24 22:52:15 1997
***************
*** 278,280 ****
--- 278,518 ----
  		len = length;
  	return len;
  }
+ 
+ #ifdef CONFIG_WEBSHIELD_DEBUG
+ /*
+  * Dump socket log diagnostics to the /proc/net/WSsocklog file.
+  *
+  * I think these routines handle buffer boundaries better than the ones
+  * above.  Where those position the *start pointer somewhere within the
+  * given buffer, this one always puts it at the start of the buffer.
+  *
+  * The pos and offset variables are both relative to the start of the file.
+  * The len and length variables are both relative to the start of the buffer.
+  * The tmplen variable is the size of the current line of data.
+  * If pos<offset, we have offset-pos bytes of old data to skip (olddata).
+  * If pos+tmplen>offset, we have tmplen-olddata bytes of new data.
+  *
+  * Change usedata() to proc_usedata() to be used by WSbridgelog file, too.
+  * Also move proc_usedata() outside of SOCKLOG_ENABLED ifdef.
+  */
+ void proc_usedata(char *buffer, char *tmpbuf, int *pos, int offset, int *len)
+ {
+ 	int olddata = 0;
+ 	int tmplen = strlen(tmpbuf);
+ 
+ 	if (tmplen + *pos > offset) {
+ 		/* We have some new data, */
+ 		if (*pos < offset)
+ 			/* and we have this much old data. */
+ 			olddata = offset - *pos;
+ 		strcpy(buffer+(*len), tmpbuf+olddata);
+ 		(*len) += tmplen - olddata;
+ 	}
+ 	(*pos) += tmplen;
+ }
+ 
+ #define SOCKLOG_ENABLED 1
+ #if SOCKLOG_ENABLED
+ /*
+  * Dump socket log diagnostics to the /proc/net/WSsocklog file.
+  * 40*10000 = 400KB
+  */
+ #define NR_SOCKLOG 10000
+ #define SOCKLOG_LIMIT 30
+ struct socklog_record {
+ 	struct socklog_record *next;
+ 	struct sock *sock;
+ 	unsigned short lport;
+ 	unsigned short rport;
+ 	int action;
+ 	unsigned int jiffies;
+ 	unsigned int seq1;
+ 	unsigned int seq2;
+ 	void *bt1;
+ 	void *bt2;
+ 	void *bt3;
+ };
+ struct socklog_record socklog_records[NR_SOCKLOG];
+ int socklog_next = 0;
+ #define socklog_ptr(sk) ((struct socklog_record *)(sk->keepalive_timer.data))
+ 
+ 
+ int WSsocklog_get_info(char *buffer, char **start, off_t offset, int length, int dummy)
+ {
+ 	int len = 0; /* offset from the start of the given buffer */
+ 	int pos = 0; /* offset from the start of the file */
+ 	int i;
+ 	struct sock *sp;
+ 	struct socklog_record *rp;
+ 	char tmpbuf[200]; /* Good enough.  I count around 150. */
+ 	char *actionstr;
+ 	int sockcnt;
+ 	int logcnt;
+ 
+ 	*start = buffer;
+ 
+ 	/*
+ 	 * Count the socklog_records usage.  Cli() is not needed as
+ 	 * this is an informal number.
+ 	 */
+ 	logcnt = 0;
+ 	for (rp = &socklog_records[0]; rp < &socklog_records[NR_SOCKLOG]; rp++){
+ 		if (rp->sock)
+ 			logcnt++;
+ 	}
+ 	sprintf(tmpbuf, "%d of %d records used\n", logcnt, NR_SOCKLOG);
+ 	proc_usedata(buffer, tmpbuf, &pos, offset, &len);
+ 	if (len >= length)
+ 		return length;
+ 
+ 	logcnt = sockcnt = 0;
+ 	for (i = 0; i < SOCK_ARRAY_SIZE; i++) {
+ 	  	cli();
+ 		for (sp = tcp_prot.sock_array[i]; sp != NULL; sp = sp->next) {
+ 			int infcount = 0;
+ 
+ 			sockcnt++;
+ 			for (rp = socklog_ptr(sp); rp; rp = rp->next) {
+ 				/* Break if socklog_record was reclaimed. */
+ 				/* I do not currently plan to do this. */
+ 				/* I will "free" records when I free socks. */
+ 				if (rp->sock != sp)
+ 					break;
+ 				if (++infcount > SOCKLOG_LIMIT)
+ 					break; /* avoid infinite loops */
+ 
+ 				logcnt++;
+ 				/* print socklog information */
+ 				switch (rp->action) {
+ 				case 1: actionstr="SYN_RECV"; break;
+ 				case 2: actionstr="SYN_SEND"; break;
+ /* ? */				case 3: actionstr="ESTABLISHED"; break;
+ 				case 4: actionstr="FIN"; break;
+ 				case 5: actionstr="CLOSE"; break;
+ 				case 6: actionstr="URG data"; break;
+ 				case 7: actionstr="DONTCARE1"; break;
+ 				case 8: actionstr="DONTCARE2"; break;
+ 				case 9: actionstr="RESET1"; break;
+ 				case 10: actionstr="TIME DONE"; break;
+ 				case 11: actionstr="setstate"; break;
+ 				case 12: actionstr="CLOSE2"; break;
+ 				case 13: actionstr="destroy_sock"; break;
+ 				case 14: actionstr="rexmit timer"; break;
+ 				case 15: actionstr="dontcare cleanup"; break;
+ 				case 16: actionstr="send_ack, deleting timer"; break;
+ 				case 17: actionstr="cleanup dead, state"; break;
+ 				case 18: actionstr="dontcare cleanup 2"; break;
+ 				default: actionstr="unknown"; break;
+ 				}
+ 				sprintf(tmpbuf, "%p(%u,%u): %s at %u,"
+ 					" seqs %u & %u from %p, %p, %p\n",
+ 					rp->sock, rp->lport, rp->rport,
+ 					actionstr, rp->jiffies, rp->seq1,
+ 					rp->seq2, rp->bt1, rp->bt2, rp->bt3);
+ 				proc_usedata(buffer, tmpbuf, &pos, offset, &len);
+ 				if (len > length)
+ 					break;
+ 			}
+ 			if (len > length)
+ 				break;
+ 		}
+ 		sti();
+ 		if (len > length)
+ 			break;
+ 	}
+ 	if (len < length) {
+ 		sprintf(tmpbuf, "\nCounted %d log records for the %d socks"
+ 			" in the proto table.\n", logcnt, sockcnt);
+ 		proc_usedata(buffer, tmpbuf, &pos, offset, &len);
+ 	}
+ 	if (len > length)
+ 		len = length;
+ 	return len;
+ }
+ 
+ void log_sockevent(struct sock *sp, int action, unsigned long seq1, unsigned long seq2)
+ {
+ 	struct socklog_record *rp, *limit;
+ 	unsigned long flags;
+ 	int count = 0;
+ 
+ 	save_flags(flags);
+ 	cli();
+ 	for (rp = socklog_ptr(sp); rp; rp = rp->next) {
+ 		if (++count >= SOCKLOG_LIMIT) {
+ 			restore_flags(flags);
+ 			return;
+ 		}
+ 	}
+ 
+ 	limit = &socklog_records[NR_SOCKLOG - 1];
+ 	for (rp = &socklog_records[socklog_next]; rp < limit; rp++) {
+ 		if (!rp->sock)
+ 			break;
+ 	}
+ 	if (rp == limit && socklog_next > 0) {
+ 		limit = &socklog_records[socklog_next];
+ 		for (rp = &socklog_records[0]; rp < limit; rp++) {
+ 			if (!rp->sock)
+ 				break;
+ 		}
+ 	}
+ 	if (rp == limit) {
+ 		restore_flags(flags);
+ 		return; /* argh, no free socklog_records */
+ 	}
+ 
+ 	/* Found a free one.  Add it to this sock's list */
+ 	rp->next = socklog_ptr(sp);
+ 	sp->keepalive_timer.data = (unsigned long) rp;
+ 
+ 	rp->sock = sp;
+ 	rp->lport = ntohs(sp->dummy_th.source);
+ 	rp->rport = ntohs(sp->dummy_th.dest);
+ 	rp->action = action;
+ 	rp->jiffies = jiffies;
+ 	rp->seq1 = seq1;
+ 	rp->seq2 = seq2;
+ 	rp->bt1 = __builtin_return_address(1);
+ 	rp->bt2 = __builtin_return_address(2);
+ 	rp->bt3 = __builtin_return_address(3);
+ 	restore_flags(flags);
+ }
+ 
+ void free_sockevents(struct sock *sp)
+ {
+ 	struct socklog_record *rp;
+ 	unsigned long flags;
+ 	int count = 0;
+ 
+ 	save_flags(flags);
+ 	cli();
+ 	for (rp = socklog_ptr(sp); rp; rp = rp->next) {
+ 		if (rp->sock != sp)
+ 			break;
+ 		if (++count >= SOCKLOG_LIMIT)
+ 			break;
+ 		rp->sock = 0;
+ 	}
+ 	restore_flags(flags);
+ }
+ #else
+ 
+ int WSsocklog_get_info(char *buffer, char **start, off_t offset, int length, int dummy)
+ {
+ 	return 0;
+ }
+ 
+ void log_sockevent(struct sock *sp, int action, unsigned long seq1, unsigned long seq2)
+ {
+ 	return;
+ }
+ 
+ void free_sockevents(struct sock *sp)
+ {
+ 	return;
+ }
+ 
+ #endif /* SOCKLOG_ENABLED */
+ #endif /* CONFIG_WEBSHIELD_DEBUG */
